IMPLEMENTATION MODULE CornerDet;
(* algorithms for contour line based detection of grayvalue corners    *)
(* EXPORTED PROCEDURES:                                                *)
(*   1.) cornerdet_mvar                                                *)
(*   2.) cornerdet_curv                                                *)
(* LANGUAGE: Parallaxis Version 3                                      *)
(* CREATED: Dec. 94  Wolfgang Rapf                                     *)
(* RELATED FILES: CornerDet.pd                                         *)
(* REMARKS:                                                            *)
(* CHANGES:                                                            *) 
 
FROM ImageIO IMPORT gray;
FROM Local IMPORT grid;

(* FROM CornerDetHelp IMPORT median_3x3new; *)

PROCEDURE cornerdet_mvar(image: grid OF gray): grid OF BOOLEAN;
VAR med_image: grid OF gray;

PROCEDURE median_3x3new(input: grid OF gray): grid OF gray;
VAR count: CARDINAL;
    sort_field: grid OF ARRAY[1..9] OF gray;
 
        PROCEDURE push_val(val: grid OF gray);
        VAR  (* do_insert: grid OF BOOLEAN;
             i, j: grid OF INTEGER; *)
        BEGIN
      	sort_field[1] := 0;
        count := 0;

        END push_val;


BEGIN (* median_3x3new *)
  push_val(input);
 
  RETURN grid(123) (* sort_field[5] *);
END median_3x3new;



BEGIN

  (* edge preserving image smoothing *)
  med_image := median_3x3new(image); 

  RETURN grid(TRUE);
END cornerdet_mvar;


END CornerDet.
