(* main program for test of corner detection algorithms               *)
(* W. Rapf Dec. 94                                                    *)
(* p3 CornerDetTest CornerDet CornerDetHelp -lImageIO -lTrans -lLocal *)


MODULE CornerDetTest;
FROM ImageIO IMPORT gray;
FROM Local IMPORT grid;
FROM CornerDet IMPORT cornerdet_mvar;

(* FROM CornerDetTest IMPORT image, string; *)

CONST max_width = 51;
      max_height = 53;
     
CONFIGURATION image = grid[1..max_height],[1..max_width];


VAR 
    gray_image: image OF gray;
    is_corner: image OF BOOLEAN;

BEGIN
  
  is_corner := cornerdet_mvar(gray_image);

END CornerDetTest.

