MODULE testif;
CONFIGURATION grid[1..10];
CONFIGURATION list[1..7];
VAR x: CARDINAL;
    xg: grid OF CARDINAL;
    xl: list OF CARDINAL;
        
BEGIN
  (* scalar IFs *)

  x := 3;
  xg := ID(xg);  
  IF (x<5) THEN				  (* IF only with THEN *)
    x:=6;
  END; (*IF*)

  IF (x<5) THEN				  (* IF with THEN and ELSE *)
    x:=6;
  ELSE
    x:=7;
  END; (*IF*)
  
  IF (x<5) THEN				  (* IF with empty THEN *)
  ELSE x:=7;
  END; (*IF*)
  
  IF (x<5) THEN				  (* IF with ELSIFs *)
    x:=6;
  ELSIF (x>7) THEN
    x:=7;
  ELSIF x>9 THEN
    x:=8;
  END; (*IF*)  

  IF (x<5) THEN				  (* IF with ELSIFs and ELSE *)
    x:=6;
  ELSIF (x>7) THEN
    x:=7;
  ELSIF x>9 THEN
    x:=8;
  ELSE
    x:=9;
  END; (*IF*)  



  (* parallel IFs *)
  
  IF (xg<3) THEN			  (* IF only with THEN *)
    xg:=2;
  END; (*IF*)

  IF (xg<5) THEN			  (* IF with THEN and ELSE *)
    xg:=4;
  ELSE
    xg:=10-xg;
  END; (*IF*)
  
  IF (xg<5) THEN			  (* IF with empty THEN *)
  ELSE xg:=2;
  END; (*IF*)
  
  IF (xg<4) THEN			  (* IF with ELSIFs *)
    xg:=3;
  ELSIF (xg>7) THEN
    xg:=4;
  ELSIF xg=4 THEN
    xg:=ID(xg)+3;
  END; (*IF*)  

  IF (xg<5) THEN			  (* IF with ELSIFs and ELSE *)
    xg:=6;
  ELSIF (xg>7) THEN
    xg:=7;
  ELSIF xg>5 THEN
    xg:=8;
  ELSE
    xg:=9;
  END; (*IF*)  


  (* parallel IFs with mixed configurations *)
  
  IF xg<4 THEN				  (* one ELSIF of each *)
    xg:=3;
  ELSIF xl>7 THEN
    xl:=4;
  ELSIF xg=4 THEN
    xg:=ID(xg)+3;
  END; (*IF*)  

  IF (xl<5) THEN			  (* one ELSIF of each, with ELSE *)
    xg:=6;
  ELSIF (xl>7) THEN
    xg:=7;
  ELSIF xg>5 THEN
    xg:=8;
  ELSE
    xg:=9;
  END; (*IF*)  

  (* mixed scalar and parallel IFs *)
  IF xg<5 THEN				  (* starting with parallel IF *)
    xg := 5;
  ELSIF x<7 THEN
    x := 8;
  ELSIF x=7 THEN
    x := 2;
  ELSIF xl<5 THEN
    xl := 5;
  ELSIF xl>5 THEN
    xl := 3;
  ELSIF xg>7 THEN
    xg := 1;
  ELSE 
    xg := 3;
  END; (*IF*)

  IF x<5 THEN				  (* starting with scalar IF *)
    x := 5;
  ELSIF xg<7 THEN
    xg := 8;
  ELSIF xg=7 THEN
    xg := 2;
  ELSIF xl<5 THEN
    xl := 5;
  ELSIF xl>5 THEN
    xl := 3;
  ELSIF x>7 THEN
    x := 1;
  ELSE 
    x := 3;
  END; (*IF*)
END testif.
