   IMPLEMENTATION MODULE Parabol12;
   
     PROCEDURE grenz(h,a1,a2,k1,k2,g1,g2:REAL; m:INTEGER);
        BEGIN
         IF IX=0 THEN 
            VL:=RECEIVE.links(VP);
            VP:=(g1+k1*VL/h)/(a1+k1/h);
         END;
         IF IX=m THEN
            VW:=RECEIVE.rechts(VP);
            VP:=(g2+k2*VW/h)/(a2+k2/h);
         END;
      END grenz;
     PROCEDURE parg(VAR V:net OF REAL; G:net OF REAL; h,s,a1,a2,k1,k2,g1,g2,ta:REAL; m:INTEGER);
       BEGIN
         IX:=DIM(net,1);
         SEND.rechts(V,VW);
         SEND.links(V,VL);
         IF(0<IX<m) THEN
           V:=VW*s+(1.0-2.0*s)*V+VL*s+ta*G;
         END;
         VP:=V;
         grenz(h,a1,a2,k1,k2,g1,g2,m);
         V:=VP;
       END parg;
    PROCEDURE anbedin(h,s,ta,a1,a2,k1,k2,g1,g2:REAL; m:INTEGER);
       BEGIN
         IF (IX<=0) OR (IX>=m) THEN
            C:=0.0; A:=1.0; B:=0.0; D:=0.0;
         END;
         IF IX=1 THEN
            C:=0.0; A:=a1+k1/h; B:=-k1/h; D:=g1;
         END;
         IF IX=(m-1) THEN
            C:=-k2/h; A:=a2+k2/h; B:=0.0; D:=g2;
         END;
         IF 1<IX<(m-1) THEN
            C:=s; A:=-(1.0+2.0*s); B:=s; D:=-VP-ta*VW;
         END;
      END anbedin;
 PROCEDURE paracr(VAR V:net OF REAL; G:net OF REAL;h,s,a1,a2,k1,k2,g1,g2,ta:REAL; m,q:INTEGER);
	VAR k,n        :INTEGER;
        BEGIN
           IX:=DIM(net,1);
         IF (0<IX<m) THEN
           VP:=V;
           VW:=G;
	   anbedin(h,s,ta,a1,a2,k1,k2,g1,g2,m);
         END;
           FOR k:=0 TO (q-1) DO
               n:=2**k;
               IF 0<=IX<=m THEN
                 SEND.rechts: n (C,CW);
                 SEND.rechts: n (A,AW);
                 SEND.rechts: n (B,BW);
                 SEND.rechts: n (D,DW);
                 SEND.links: n (C,CL);
                 SEND.links: n (A,AL);
                 SEND.links: n (B,BL);
                 SEND.links: n (D,DL);
                 IW:=IX-n; IL:=IX+n;
              END;
              IF 0<IW<m THEN
                 AI:=-C/AW;
                 C:= AI*CW;
                 A:=A+AI*BW;
                 D:=D+AI*DW;
              END;
              IF 0<IL<m THEN
                 BI:=-B/AL;
                 B:= BI*BL;
                 A:=A+BI*CL;
                 D:=D+BI*DL;
              END;
           END;
           IF 0<IX<m THEN
              V:=D/A;
           END;
        END paracr;
     PROCEDURE grenz2(h,a1,a2,a3,a4,k1,k2,k3,k4,g1,g2,g3,g4:REAL; m,n:INTEGER);
        BEGIN
         IF (IX=0) AND (0<=JY<n) THEN
            VL:=RECEIVE.links(VP);
            VP:=(g1+k1*VL/h)/(a1+k1/h);
         END;
         IF (IX=m) AND (0<JY<=n) THEN
            VW:=RECEIVE.rechts(VP);
            VP:=(g2+k2*VW/h)/(a2+k2/h);
         END;
         IF (0<IX<=m) AND (JY=0) THEN
             VS:=RECEIVE.ub(VP);
             VP:=(g3+k3*VS/h)/(a3+k3/h);
         END;
         IF (0<=IX<m) AND (JY=n) THEN
             VN:=RECEIVE.un(VP);
             VP:=(g4+k4*VN/h)/(a4+k4/h);
         END;
      END grenz2;
     
 PROCEDURE parg2(VAR V:net OF REAL;G:net OF REAL;h,s,a1,a2,a3,a4,k1,k2,k3,k4,g1,g2,g3,g4,ta:REAL;m,n:INTEGER);
       BEGIN
         IX:=DIM(net,1);
         JY:=DIM(net,2);
         SEND.rechts(V,VW);
         SEND.links(V,VL);
         SEND.ub(V,VS);
         SEND.un(V,VN);
         IF (0<IX<m) AND (0<JY<n) THEN
           V:=(VW+VL+VS+VN)*s+(1.0-4.0*s)*V+ta*G;
         END;
         VP:=V;
         grenz2(h,a1,a2,a3,a4,k1,k2,k3,k4,g1,g2,g3,g4,m,n);
         V:=VP;
       END parg2;
    PROCEDURE anbedin2(h,s,ta,a1,a2,k1,k2,g1,g2:REAL; m:INTEGER);
       BEGIN
         IF (I<=0) OR (I>=m) THEN
            C:=0.0; A:=1.0; B:=0.0; D:=0.0;
         END;
         IF I=1 THEN
            C:=0.0; A:=a1+k1/h; B:=-k1/h; D:=g1;
         END;
         IF I=(m-1) THEN
            C:=-k2/h; A:=a2+k2/h; B:=0.0; D:=g2;
         END;
         IF (1<I<(m-1)) THEN
            C:=s; A:=-(1.0+2.0*s); B:=s; D:=-VP-0.5*ta*VW;
         END;
      END anbedin2;
 PROCEDURE paracr2(VAR V:net OF REAL; G:net OF REAL;h,s,a1,a2,a3,a4,k1,k2,k3,k4,g1,g2,g3,g4,ta:REAL; m,q,n,q1:INTEGER);
	VAR k,j        :INTEGER;
        BEGIN
           IX:=DIM(net,1);
         JY:=DIM(net,2);
         IF (0<IX<m) THEN
           VP:=V;
           VW:=G;
         END;
           I:=IX;
	   anbedin2(h,s,ta,a1,a2,k1,k2,g1,g2,m);
           FOR k:=0 TO (q-1) DO
               j:=2**k;
               IF 0<=IX<=m THEN
                 SEND.rechts: j (C,CW);
                 SEND.rechts: j (A,AW);
                 SEND.rechts: j (B,BW);
                 SEND.rechts: j (D,DW);
                 SEND.links: j (C,CL);
                 SEND.links: j (A,AL);
                 SEND.links: j (B,BL);
                 SEND.links: j (D,DL);
                 IW:=IX-j; IL:=IX+j;
              END;
              IF 0<IW<m THEN
                 AI:=-C/AW;
                 C:= AI*CW;
                 A:=A+AI*BW;
                 D:=D+AI*DW;
              END;
              IF 0<IL<m THEN
                 BI:=-B/AL;
                 B:= BI*BL;
                 A:=A+BI*CL;
                 D:=D+BI*DL;
              END;
           END;
           IF 0<IX<m THEN
              V:=D/A;
           END;
       VP:=V;
       VW:=G;
      I:=JY;
      anbedin2(h,s,ta,a3,a4,k3,k4,g3,g4,n);
           FOR k:=0 TO (q1-1) DO
               j:=2**k;
               IF 0<=JY<=n THEN
                 SEND.ub: j (C,CW);
                 SEND.ub: j (A,AW);
                 SEND.ub: j (B,BW);
                 SEND.ub: j (D,DW);
                 SEND.un: j (C,CL);
                 SEND.un: j (A,AL);
                 SEND.un: j (B,BL);
                 SEND.un: j (D,DL);
                 IW:=JY-j; IL:=JY+j;
              END;
              IF 0<IW<n THEN
                 AI:=-C/AW;
                 C:= AI*CW;
                 A:=A+AI*BW;
                 D:=D+AI*DW;
              END;
              IF 0<IL<n THEN
                 BI:=-B/AL;
                 B:= BI*BL;
                 A:=A+BI*CL;
                 D:=D+BI*DL;
              END;
           END;
           IF 0<JY<n THEN
              V:=D/A;
           END;
        END paracr2;
    END Parabol12.
