     MODULE Parexp2;
     FROM Parabol2 IMPORT parg2, net;
    CONST m=7; n=7; k=5; h=0.142857;    
           c=0.5; a=1.0; b=1.0; ta=0.01; al=2.0;
         a1=1.0; a2=1.0; k1=0.0; k2=0.0; g1=0.0; g2=0.0;
         a3=1.0; a4=1.0; k3=0.0; k4=0.0; g3=0.0; g4=0.0;
     VAR t,d,s         :REAL;
         i          :INTEGER;
         IX,JY          :net OF INTEGER;
        V,G         : net OF REAL;
     PROCEDURE rteil(t: REAL): net OF REAL;
          VAR Fx,Fy,F               : net OF REAL;
     BEGIN
      Fx:= h*FLOAT(DIM(net,1));
      Fy:= h*FLOAT(DIM(net,2));
      F:=exp(-t*al)*sin(pi*Fx/a)*sin(pi*Fy/b);
      RETURN F;
     END rteil;
     BEGIN
          t:=0.0;
          d:=pi*pi*c*(1.0/a/a+1.0/b/b)-al;
          s:=c/h*ta/h;
          IX:=DIM(net,1);
          JY:=DIM(net,2);
          OpenOutput("Parexp2.out");
          WriteString('   Die Ergebnisse der expliziten Methode       ');
          WriteLn;
          IF (0<=IX<=m) THEN
           IF (0<=JY<=n) THEN
            V:=rteil(t);
            WriteFixPt(V,6,4);
          END;
         END;
         IF (0<=IX<=m) AND (0<=JY<=n) THEN
            FOR i:=1 TO k DO
              G:=rteil(t); G:=d*G;
              t:=t+ta;
              parg2(V,G,h,s,a1,a2,a3,a4,k1,k2,k3,k4,g1,g2,g3,g4,ta,m,n);
            WriteString('      Der Zeitschritt ist gleich   ');
            WriteInt(i,3); WriteLn;
            WriteFixPt(V,6,4);
            END;
         END;
             CloseOutput;
     END Parexp2.
