(************************************************************************)
(*  Filename:    testStdProc1.pm					*)
(*  Author:	 Hartmut Keller						*)
(*  Last Change: Mon Sep  4 11:36:11 1995				*)
(*									*)
(*  Description:							*)
(*  ------------							*)
(*  This file checks some Parallaxis standard procedures/functions. It  *)
(*  expects some of the Write-procedures to work.                       *)
(************************************************************************)

MODULE testStdProc1;

TYPE enumtype=(one, two, three, four);

CONFIGURATION list[-3..5];
              grid[one..three],['a'..'e'];

BEGIN
  WriteString("RANK(list) = ");        WriteCard(RANK(list), 1); 
  WriteString("  LEN(list)  = ");      WriteCard(LEN(list), 1);    WriteLn;
  WriteString("LOWER(list,1) = ");     WriteInt(LOWER(list,1), 1);
  WriteString("  UPPER(list,1) = ");   WriteInt(UPPER(list,1), 1);
  WriteString("  LEN(list,1)= ");      WriteCard(LEN(list,1), 1);  WriteLn;
  WriteString("ID(list) = "); WriteLn; WriteCard(ID(list),3);      WriteLn;

  WriteString("RANK(grid) = ");        WriteCard(RANK(grid), 1);
  WriteString("  LEN(grid)  = ");      WriteCard(LEN(grid), 1);    WriteLn;
  WriteString("LOWER(grid,1) = ");     WriteInt(LOWER(grid,1), 1);
  WriteString("  UPPER(grid,1) = ");   WriteInt(UPPER(grid,1), 1);
  WriteString("  LEN(grid,1)= ");      WriteCard(LEN(grid,1), 1);  WriteLn;
  WriteString("LOWER(grid,2) = ");     WriteInt(LOWER(grid,2), 1);
  WriteString("  UPPER(grid,2) = ");   WriteInt(UPPER(grid,2), 1);
  WriteString("  LEN(grid,2)= ");      WriteCard(LEN(grid,2), 1);  WriteLn;
  WriteString("ID(grid) = "); WriteLn; WriteCard(ID(grid),3);      WriteLn;
END testStdProc1.

