#ifndef _ImageIO_h
#define _ImageIO_h

#define ImageIO_b_black TRUE
#define ImageIO_b_white FALSE
#define ImageIO_g_black 0
#define ImageIO_g_white 255
typedef BOOLEAN ImageIO_binary;
typedef CARDINAL ImageIO_gray;
typedef struct ImageIO_1 {
    ImageIO_gray red, green, blue;
} ImageIO_color;
extern ImageIO_color ImageIO_c_black;
extern ImageIO_color ImageIO_c_white;
extern ImageIO_color ImageIO_c_red;
extern ImageIO_color ImageIO_c_green;
extern ImageIO_color ImageIO_c_blue;
extern void ImageIO_read_c_image ARGS((ImageIO_color im[], CHAR filename[], CARDINAL , CARDINAL *width, CARDINAL *height, CONFIGURATION OPEN_VECTOR));
extern void ImageIO_read_g_image ARGS((ImageIO_gray im[], CHAR filename[], CARDINAL , CARDINAL *width, CARDINAL *height, CONFIGURATION OPEN_VECTOR));
extern void ImageIO_read_b_image ARGS((ImageIO_binary im[], CHAR filename[], CARDINAL , CARDINAL *width, CARDINAL *height, CONFIGURATION OPEN_VECTOR));
extern void ImageIO_write_c_image ARGS((ImageIO_color im[], CHAR filename[], CARDINAL , CARDINAL width, CARDINAL height, CONFIGURATION OPEN_VECTOR));
extern void ImageIO_write_g_image ARGS((ImageIO_gray im[], CHAR filename[], CARDINAL , CARDINAL width, CARDINAL height, CONFIGURATION OPEN_VECTOR));
extern void ImageIO_write_b_image ARGS((ImageIO_binary im[], CHAR filename[], CARDINAL , CARDINAL width, CARDINAL height, CONFIGURATION OPEN_VECTOR));
extern void BEGIN_ImageIO();

#endif
