/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name :  Statist.h
 * desc :  functions to show statistics to the user
 * rcs  :  $Author: lampke $
 *
 ************************************************************************/

#ifndef Statist_h
#define Statist_h

#include "parallaxis.h"

/*************************************************************************
 * name :  WritePhase
 * in   :  string 'phase' to descibe actual phase
 * out  :
 ************************************************************************/
extern void Statist_WritePhase( char *phase );

/*************************************************************************
 * name :  StartOver
 * in   :
 * out  :
 ************************************************************************/
extern void Statist_StartOver( void );

/*************************************************************************
 * name :  WriteMemory
 * in   :
 * out  :
 ************************************************************************/
extern void Statist_WriteMemory( void );

/*************************************************************************
 * name :  WriteStepTime
 * in   :
 * out  :
 ************************************************************************/
extern void Statist_WriteStepTime( void );

/*************************************************************************
 * name :  WriteCompTime
 * in   :
 * out  :
 ************************************************************************/
extern void Statist_WriteCompTime( void );

extern void Statist_Init( void );

#endif
