/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name  :  parameter
 * desc  :
 * author:  lampke
 *
 ************************************************************************/

#ifndef _Parameter_h
#define _Parameter_h

#include "Idents.h"			  /* Reuse-Library */
#include "parallaxis.h"
#include "Symbols.h"

/*
 * pointer to CObjects
 */

extern tCObjects Parameter_ValueOpens;
extern tCObjects Parameter_VAROpens;

/*************************************************************************
 * name: Parameter_GenParams
 * in  :
 * out : generates parameter CIdentifiers
 ************************************************************************/

extern void Parameter_GenParams( tCObjects openParams );

/*************************************************************************
 * name: Parameter_GetParam
 * in  :
 * out : gets parameter from symbols
 ************************************************************************/

extern tIdent Parameter_GetParam( tObject m2object );

/*************************************************************************
 * name: Parameter_Init
 * in  :
 * out : init
 ************************************************************************/

extern void Parameter_Init( void );

#endif
