#include <stdio.h>
#include <malloc.h>

extern char *mktemp();

#define STRINGBLOCKSIZE 5
typedef struct
{
     int entries;
     char **strings;
} stringarray;

void printstrings(stringarray array)
{
     int i;
     for (i=0; i<array.entries; i++)
	  printf("%d: %s\n",i, array.strings[i]);
}


void addstring(stringarray *array, char *string)
{
     if (array->entries == 0)		  /* empty list? get a block */
     {
	  array->strings = (char **) malloc(STRINGBLOCKSIZE * sizeof(char *));
     }
     else if (array->entries % STRINGBLOCKSIZE == 0) /* block full? get */
     {						    /* another block */
	  array->strings = (char **) realloc( array->strings,
					    (array->entries+STRINGBLOCKSIZE)
					    * sizeof(char *));
     }
     array->strings[array->entries++] = string; /* insert string in array */
}

stringarray feld = {0, NULL};
char text[]="hurgaXXXXXX";


void main(int argc, char *argv[])
{
     int i;
     for (i=0; i<argc; i++)
	  addstring(&feld, argv[i]);

     for (i=0; i<500; i++)
	  addstring(&feld, tempnam(NULL, "p3c"));

     for (i=0; i<5; i++)
	  addstring(&feld, mktemp(text));

     printstrings(feld);
}



