   MODULE Parexp1;
    FROM Parabol12 IMPORT parg, net;
    CONST m=7; n=20; h=0.142857;    
           a=0.5; l=1.0; ta=0.01; al=2.0;
         a1=1.0; a2=1.0; k1=0.0; k2=0.0; g1=0.0; g2=0.0;
     VAR t,s,b         :REAL;
         i          :INTEGER;
         IX,JY          :net OF INTEGER;
        V,G         : net OF REAL;
     PROCEDURE rteil(t:REAL): net OF REAL;
        VAR F      :net OF REAL;
        BEGIN
          F:=h*FLOAT(IX);
          F:=exp(-t*al)*sin(pi*F/l);
          RETURN F;
         END rteil;
      BEGIN
          t:=0.0;
          b:=pi/l*pi/l*a-al;
          s:=a/h*ta/h;
          IX:=DIM(net,1);
          JY:=DIM(net,2);
          OpenOutput("Parexp1.out");
          WriteString('   Die Ergebnisse der expliziten Methode       ');
          WriteLn;
          IF (0<=IX<=m) AND (JY=0) THEN
            V:=rteil(t);
            WriteFixPt(V,6,4);
            FOR i:=1 TO n DO
              G:=rteil(t); G:=b*G;
              t:=t+ta;
              parg(V,G,h,s,a1,a2,k1,k2,g1,g2,ta,m);
            WriteFixPt(V,6,4);
            END;
             CloseOutput;
          END;
     END Parexp1.
