    MODULE Parimpl1;
     FROM Parabol12 IMPORT paracr,net;
     CONST m=9; h=0.142857; a=0.5; ta=0.05; q=3; 
           n=20; k1=0.0; k2=0.0; g1=0.0; g2=0.0;
           a1=1.0; a2=1.0; al=2.0; l=1.0;

     VAR i,k         :INTEGER;
         t,s,b             :REAL;
         V,G           : net OF REAL;
         IW,IX,JY,IL                                :net OF INTEGER;
     PROCEDURE rteil(t:REAL): net OF REAL;
        VAR F      :net OF REAL;
        BEGIN
          F:=h*FLOAT(IX-1);
          F:=exp(-t*al)*sin(pi*F/l);
          RETURN F;
         END rteil;
      BEGIN
          t:=0.0;
          b:=pi/l*pi/l*a-al;
          s:=a/h*ta/h;
          IX:=DIM(net,1);
          JY:=DIM(net,2);
          OpenOutput("Parimpl1.out");
          WriteString('   Die Ergebnisse der impliziten Methode       ');
          WriteLn;
          IF (0<=IX<=m) THEN
            V:=rteil(t);
          END;
          IF (0<IX<m) AND (JY=0) THEN
            WriteFixPt(V,6,4);
          END;
            FOR i:=1 TO n DO
              t:=t+ta;
             IF (0<=IX<=m) THEN
              G:=rteil(t); G:=b*G;
              paracr(V,G,h,s,a1,a2,k1,k2,g1,g2,ta,m,q);
             END;
             IF(0<IX<m) AND (JY=0) THEN
               WriteFixPt(V,6,4);
             END;
         END;
             CloseOutput;
      END Parimpl1.
