MODULE pepper;
IMPORT ImageIO, Trans, Local;

CONST width = 375;
      height= 275;
CONFIGURATION image = Local.grid[1..height],[1..width];

VAR g1,g2   : image OF ImageIO.gray;
    r       : image OF INTEGER;
    w,h     : INTEGER;

BEGIN
  ImageIO.read_g_image(g1,"",w,h);
  r := RandomInt(image) MOD 200;
  IF r = 0       THEN g1 := ImageIO.g_white  (* salt *)
   ELSIF r = 100 THEN g1 := ImageIO.g_black  (* pepper *)
  END;
  ImageIO.write_g_image(g1,"g2.pepper",w,h);

  g2 := Local.min_3x3(g1);
  ImageIO.write_g_image(g2,"g2.min",w,h);
  g2 := Local.max_3x3(g1);
  ImageIO.write_g_image(g2,"g2.max",w,h);

  g2 := Local.mean_3x3(g1);
  ImageIO.write_g_image(g2,"g2.mean",w,h);
  g2 := Local.median_3x3fast(g1);
  ImageIO.write_g_image(g2,"g2.medfast",w,h);
  g2 := Local.median_3x3(g1);
  ImageIO.write_g_image(g2,"g2.median",w,h);
END pepper.

